var b = Object.defineProperty;
var U = (e) => {
  throw TypeError(e);
};
var V = (e, t, s) => t in e ? b(e, t, { enumerable: !0, configurable: !0, writable: !0, value: s }) : e[t] = s;
var a = (e, t, s) => V(e, typeof t != "symbol" ? t + "" : t, s), B = (e, t, s) => t.has(e) || U("Cannot " + s);
var N = (e, t, s) => (B(e, t, "read from private field"), s ? s.call(e) : t.get(e)), C = (e, t, s) => t.has(e) ? U("Cannot add the same private member more than once") : t instanceof WeakSet ? t.add(e) : t.set(e, s), Y = (e, t, s, r) => (B(e, t, "write to private field"), r ? r.call(e, s) : t.set(e, s), s);
var c = /* @__PURE__ */ ((e) => (e[e.CREATE_PROMISE_FAILED = 1] = "CREATE_PROMISE_FAILED", e[e.TIMEOUT = 2] = "TIMEOUT", e[e.ABORT = 3] = "ABORT", e[e.RETRY_EXCEED_LIMIT = 4] = "RETRY_EXCEED_LIMIT", e[e.RETRY_CAN_RETRY_FN_FAILED = 5] = "RETRY_CAN_RETRY_FN_FAILED", e[e.RETRY_DELAY_FN_FAILED = 6] = "RETRY_DELAY_FN_FAILED", e))(c || {}), i = /* @__PURE__ */ ((e) => (e[e.NOT_STARTED = -1] = "NOT_STARTED", e[e.PENDING = 0] = "PENDING", e[e.FULFILLED = 1] = "FULFILLED", e[e.REJECTED = 2] = "REJECTED", e))(i || {});
const J = {
  [c.CREATE_PROMISE_FAILED]: "创建Promise失败",
  [c.TIMEOUT]: "超时",
  [c.ABORT]: "中止",
  [c.RETRY_EXCEED_LIMIT]: "重试超出限制",
  [c.RETRY_CAN_RETRY_FN_FAILED]: "重试判断是否可以重试函数执行失败",
  [c.RETRY_DELAY_FN_FAILED]: "重试延迟函数执行失败"
};
class _ extends Error {
  constructor(t, s = J[t]) {
    super(s), this.code = t;
  }
}
const v = (e, t) => {
  try {
    return e();
  } catch (s) {
    return t(s);
  }
}, P = (e) => v(e, (t) => new Promise((s, r) => {
  r(
    new _(
      c.CREATE_PROMISE_FAILED,
      (t == null ? void 0 : t.message) || void 0
    )
  );
})), $ = (e, { rejectClean: t = !0, resolveClean: s = !0 } = {}) => {
  let r, n = i.NOT_STARTED;
  return {
    /** 获取promise状态 */
    getStatus: () => n,
    /** 是否存在promise */
    isHasPromise: () => n !== i.NOT_STARTED,
    /** 应用promise */
    applyPromise: () => r || (n = i.PENDING, r = P(() => e()), r.then(() => {
      n = i.FULFILLED, s && (r = void 0);
    }).catch(() => {
      n = i.REJECTED, t && (r = void 0);
    }), r.finally(() => {
      n = i.NOT_STARTED;
    }), r),
    /** 清除promise */
    clearPromise: async () => {
      switch (n) {
        case i.NOT_STARTED: {
          console.warn("Promise sharing: promise clear，promise未开始");
          return;
        }
        case i.PENDING:
          return console.warn("Promise sharing: promise clear，promise等待中"), r.finally(() => {
            r = void 0;
          });
        case i.FULFILLED:
        case i.REJECTED: {
          r = void 0;
          return;
        }
      }
    },
    /** 获取当前promise */
    getCurrentPromise: () => r
  };
};
class D extends _ {
  constructor(s) {
    super(
      s.code,
      s.message || `包括首次执行, 总共执行${s.retryCount + 1}次, 总共运行耗时${s.runTime}ms, 最终仍失败`
    );
    /** 重试次数 */
    a(this, "retryCount");
    /** 运行时间 */
    a(this, "runTime");
    /** 错误列表 */
    a(this, "errorMessageList");
    this.retryCount = s.retryCount, this.runTime = s.runTime, this.errorMessageList = s.errorMessageList;
  }
  /** 创建重试错误 */
  static create(s) {
    return new D(s);
  }
}
const H = (e, {
  maxRetry: t = 0,
  maxRunTime: s = 1 / 0,
  maxErrorMessageListLength: r = 10,
  canRetry: n = ({ retryCount: F, runTime: y }) => F < Math.max(t, 0) && y < s,
  delay: A = 0
}) => {
  const F = Math.max(r, 1), y = typeof A == "function" ? A : () => A;
  let w = !1, h;
  const z = () => {
    let T = 0, Z = Date.now();
    const u = [], S = new Promise((k, g) => {
      const f = () => {
        P(() => e(T)).then(k).catch((L) => {
          u.push((L == null ? void 0 : L.message) || "未知错误");
          const x = u.length, O = Math.max(
            x - F,
            0
          );
          O > 0 && u.splice(
            x - O,
            O
          );
          const l = Date.now() - Z;
          if (v(
            () => n({ retryCount: T, runTime: l }, L),
            (m) => {
              const E = D.create({
                retryCount: T,
                runTime: l,
                errorMessageList: u,
                code: c.RETRY_CAN_RETRY_FN_FAILED,
                message: (m == null ? void 0 : m.message) || void 0
              });
              throw g(E), E;
            }
          )) {
            if (w)
              return g(
                D.create({
                  retryCount: T,
                  runTime: l,
                  errorMessageList: u,
                  code: c.ABORT
                })
              );
            const m = v(
              () => y({ retryCount: T, runTime: l }, L),
              (E) => {
                const G = D.create({
                  retryCount: T,
                  runTime: l,
                  errorMessageList: u,
                  code: c.RETRY_DELAY_FN_FAILED,
                  message: (E == null ? void 0 : E.message) || void 0
                });
                throw g(G), G;
              }
            );
            if (m > 0) {
              T++;
              const E = setTimeout(f, m);
              h = () => {
                clearTimeout(E), g(
                  D.create({
                    retryCount: T,
                    runTime: l,
                    errorMessageList: u,
                    code: c.ABORT
                  })
                );
              };
            } else
              T++, f();
          } else
            g(
              D.create({
                retryCount: T,
                runTime: l,
                errorMessageList: u,
                code: c.RETRY_EXCEED_LIMIT
              })
            );
        }).finally(() => {
          h = void 0;
        });
      };
      f();
    });
    return S.finally(() => {
      w = !1;
    }), S;
  }, { getStatus: d, applyPromise: K, getCurrentPromise: Q } = $(
    z,
    {
      rejectClean: !0,
      resolveClean: !0
    }
  );
  return {
    /** 开始重试 */
    startRetry: () => K(),
    /** 停止重试 */
    stopRetry: () => (w = !0, h == null || h(), Q()),
    /** 获取重试状态 */
    getStatus: d,
    /** 判断是在重试中 */
    isRetrying: () => d() === i.PENDING
  };
};
class q extends _ {
  constructor(t = J[c.ABORT]) {
    super(c.ABORT, t);
  }
}
var p;
const I = class I {
  constructor(t) {
    /** promise原始reject函数 */
    C(this, p);
    Y(this, p, t);
  }
  /** 取消 promise */
  cancel(t) {
    N(this, p).call(this, t);
  }
};
p = new WeakMap(), /** 是否取消错误 */
a(I, "isCancelError", (t) => t instanceof q), /** 创建 promise 取消令牌 */
a(I, "source", (t) => new I(t));
let M = I;
function X(e, t) {
  return P(e).catch(() => typeof t == "function" ? t() : t);
}
const tt = (...e) => {
  const {
    startRetry: t,
    stopRetry: s,
    getStatus: r,
    isRetrying: n
  } = H(...e);
  return {
    /** 开始轮询 */
    startPolling: t,
    /** 停止轮询 */
    stopPolling: s,
    /** 获取轮询状态 */
    getStatus: r,
    /** 判断是在轮询中 */
    isPolling: n
  };
};
let et = 0;
const st = (e, t) => (s, r) => {
  t.resolveWrap = (n) => {
    t.state === i.PENDING && (t.endTime = Date.now(), t.clearTimeoutTimer(), s(n));
  }, t.rejectWrap = (n) => {
    t.state === i.PENDING && (t.endTime = Date.now(), t.clearTimeoutTimer(), r(n));
  }, e(t.resolveWrap, t.rejectWrap);
}, rt = (e) => {
  const t = {
    timeoutTimer: void 0,
    clearTimeoutTimer() {
      this.timeoutTimer && (clearTimeout(this.timeoutTimer), this.timeoutTimer = void 0);
    },
    startTime: Date.now(),
    state: i.PENDING,
    num: 0,
    index: et++
  }, s = st(e, t);
  return t.promise = new Promise(s), t.promise.catch((r) => {
    var n;
    return t.state === i.PENDING && ((n = t.rejectWrap) == null || n.call(t, r)), r;
  }), {
    baseInfo: t
  };
};
var j, R;
j = Symbol.toStringTag;
const o = class o {
  constructor(t) {
    a(this, j, `object ${o.name}`);
    /** 原始promise上下文 */
    C(this, R);
    /** 超时设置 */
    a(this, "timeout", (t) => {
      const { baseInfo: s } = N(this, R);
      if (s.state !== i.PENDING)
        return this;
      s.clearTimeoutTimer();
      const r = Math.max(0, s.startTime + t - Date.now());
      return s.timeoutTimer = setTimeout(() => {
        s.rejectWrap(new _(c.TIMEOUT));
      }, r), this;
    });
    /** 中止promise */
    a(this, "abort", (t) => {
      const { baseInfo: s } = N(this, R);
      return s.state !== i.PENDING ? (console.warn("取消失败，promise状态不为pending"), this) : (M.source((n) => {
        s.rejectWrap(new q(n));
      }).cancel(t), this);
    });
    Y(this, R, rt(t));
  }
  // 修正 then 方法
  then(t, s) {
    return new o((r, n) => {
      N(this, R).baseInfo.promise.then(t, s).then(r, n);
    });
  }
  // 修正 catch 方法
  catch(t) {
    return this.then(void 0, t);
  }
  // 修正 finally 方法
  finally(t) {
    return new o((s, r) => {
      N(this, R).baseInfo.promise.finally(t).then(s, r);
    });
  }
};
R = new WeakMap(), /** promise共享 */
a(o, "useSharing", $), /** promise重试 */
a(o, "useRetry", H), /** promise轮询 */
a(o, "usePolling", tt), /** promise无错 */
a(o, "noReject", X), /** 是否是取消/中止错误 */
a(o, "isCancelError", M.isCancelError), /** 是否是超时错误 */
a(o, "isTimeoutError", (t) => t instanceof _ && t.code === c.TIMEOUT);
let W = o;
export {
  W as XPromise,
  q as XPromiseCancelError,
  M as XPromiseCancelToken,
  _ as XPromiseError,
  c as XPromiseErrorCodeEnum,
  J as XPromiseErrorCodeEnumMap,
  D as XPromiseRetryError,
  i as XPromiseStateEnum,
  v as catchFnExecError,
  P as ensureCreatePromiseFlowNormal,
  X as promiseNoReject,
  tt as usePromisePolling,
  H as usePromiseRetry,
  $ as usePromiseSharing
};
