/** promise 轮询 */
export declare const usePromisePolling: <T>(args_0: (retryCount: number, err?: any) => Promise<T>, args_1: import('./retry').XPromiseRetryOptions) => {
    /** 开始轮询 */
    startPolling: () => Promise<T>;
    /** 停止轮询 */
    stopPolling: () => Promise<T> | undefined;
    /** 获取轮询状态 */
    getStatus: () => import('..').XPromiseStateEnum;
    /** 判断是在轮询中 */
    isPolling: () => boolean;
};
